<template>
  <div class="white-block">
    <div class="padding">
      <h3>Паспортные данные</h3>
    </div>
    <hr/>
    <div class="padding">
      <div class="row">
        <div class="columns four">
          <label for="passport">Серия и номер</label>
          <input type="tel"
                 name="passport"
                 id="passport"
                 v-validate="'required|serialAndNumber'"
                 :class="[getValidateClass('passport'), {'data-processing': SUGGESTIONS_LOADER.passport}]"
                 v-model="$user.passport"
                 v-mask="'#### ######'"
                 ref="passport"
                 :guide="true"
                 placeholder="1234 567890"
                 :keepCharPositions="true"
                 autocomplete="off"
                 data-code="passportInvalidFormat, passportTooShort, passportTooLong, userPassportDataNotUnique"
          >
          <validate-message v-show="vErrors.has('passport')">
            {{ vErrors.first('passport') }}
          </validate-message>
          <validate-message v-if="userPassportDataNotUnique">
            Указанные данные уже зарегистрированы. <router-link to="/lk/login">Перейдите в личный кабинет</router-link>
          </validate-message>
        </div>

        <div class="columns four">
          <label for="passportDivisionCode">Код подразделения</label>
          <input type="tel"
                 name="passportDivisionCode"
                 id="passportDivisionCode"
                 v-validate="'required|passportCode'"
                 :class="[getValidateClass('passportDivisionCode'), {'data-processing': SUGGESTIONS_LOADER.code_division}]"
                 v-model="$user.passportDivisionCode"
                 v-mask="'###-###'"
                 :guide="true"
                 placeholder="123-456"
                 :keepCharPositions="true"
                 @keyup="getWhoIssued()"
                 autocomplete="off"
                 data-code="passportDivisionCodeInvalidFormat, passportDivisionCodeTooShort, passportDivisionCodeTooLong"
          >
          <validate-message v-show="vErrors.has('passportDivisionCode')">
            {{ vErrors.first('passportDivisionCode') }}
          </validate-message>
        </div>

        <div class="columns four">
          <label for="passportDateOfIssue">Дата выдачи</label>
          <input type="tel"
                 name="дата выдачи"
                 id="passportDateOfIssue"
                 v-validate="formatDatePassport"
                 :class="getValidateClass('дата выдачи')"
                 v-model="$user.passportDateOfIssue"
                 v-mask="'##.##.####'"
                 :guide="true"
                 ref="bar"
                 :keepCharPositions="true"
                 placeholder="ДД.ММ.ГГГГ"
                 autocomplete="off"
                 data-code="passportDateOfIssueLowerThenMin, passportDateOfIssueGreaterThenMax, passportDateOfIssueInvalidDateFormat, passportDateOfIssueLowerThenBirthDate"
          >
          <validate-message v-show="vErrors.has('дата выдачи')">
            {{ vErrors.first('дата выдачи') }}
          </validate-message>
        </div>
      </div>
    </div>

    <div class="row">
      <div class="column padding-30px">
        <label for="passportIssuedBy">Кем выдан</label>
        <input type="text"
               name="passportIssuedBy"
               id="passportIssuedBy"
               v-validate="'required|exceptLatinAndServiceChar|min:6|max:190'"
               :class="getValidateClass('passportIssuedBy')"
               v-model="$user.passportIssuedBy"
               :guide="true"
               placeholder="Выдан отделением ..."
               @change="setValue('passportIssuedBy')"
               :keepCharPositions="true"
               ref="issued"
               autocomplete="off"
               data-code="passportIssuedByInvalidFormat, passportIssuedByTooShort, passportIssuedByTooLong"
        >
        <validate-message v-show="vErrors.has('passportIssuedBy')">
          {{ vErrors.first('passportIssuedBy') }}
        </validate-message>
      </div>

    </div>
  </div>
</template>

<script>
  import UserGetter from '@/mixins/User/UserGetterMixin'
  import UserSetter from '@/mixins/User/UserSetterMixin'
  import UserErrorText from '@/mixins/User/UserErrorTextMixin'
  import IndicatorRegistration from '@/mixins/IndicatorRegistration'
  import ValidateMessage from '@/components/Validators/ValidateMessage'
  import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
  import { REQUIRED_FIELD, MIN_LENGHT, MAX_LENGHT } from '@/components/Validators/CustomVeeValidateMessage'
  // import backendApi from '@/utils/backend-api'
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'
  import {mapGetters} from 'vuex'
  import dayjs from 'dayjs'
  const dateFrom = '25.12.1991'
  const dateTo = dayjs().format('DD.MM.YYYY')
  let request;
  let passportNumber;
  let passportCode;

  export default {
    name: 'user-passport-data',
    mixins: [
      UserGetter,
      UserSetter,
      UserErrorText,
      IndicatorRegistration,
      GetValidateClass,
      ErrorHandleMixin
    ],
    components: {
      ValidateMessage
    },
    data () {
      return {
        formatDatePassport: `required|date_format_check|date_between_passport|date_passport_validate`,
        passportIssuedBy: '',
        userPassportDataNotUnique: false
      }
    },
    computed: {
      ...mapGetters(['SUGGESTIONS_LOADER'])
    },
    watch: {
      '$user.passport' () {
        this.checkPassportForUnique()
      },
      '$user.passportDivisionCode' () {
        this.getWhoIssued()
      }
    },
    methods: {

      async checkPassportForUnique () {
        if (this.$route.name === 'registration') {
          const n = this.$user.passport ? this.$user.passport.replace(/[^\d]/g, '') : ''
          if (n.length === 10 && n != passportNumber) {
            passportNumber = n;
            console.log(n)
            // this.$store.commit('SUGGESTIONS_SET_LOADER', {passport: true}); // включаем лоадер, пока грузяться данные

            if(request) {
              request.abort(); // отменяем предыдующие запросы, если запросы не успели подгрузиться
            }

            request = await this.$store.dispatch('SUGGESTIONS_GET_PASSPORT', n);

            request.onreadystatechange = function () {
              // результат на то, что введены верно серия и номер
              if(request.readyState === XMLHttpRequest.DONE) {
                switch (request.status) {
                  case 200:
                    this.userPassportDataNotUnique = false;
                    this.$emit('error', {
                      key: 'userNotUnique',
                      value: false
                    });
                    break;
                  case 400:
                    if (this.$getErrorCode(request.response) === 'userPassportDataNotUnique') {
                      this.userPassportDataNotUnique = true;
                      this.$emit('error', {
                        key: 'userNotUnique',
                        value: true
                      })
                    }
                    break;
                }
                // this.$store.commit('SUGGESTIONS_SET_LOADER', {passport: false});
                request = null;
              }
            }.bind(this);
          }
        }
      },
      async getWhoIssued () {
        let data = this.$user.passportDivisionCode.replace(/-/, '');
        if (data.length === 6 && data != passportCode) {

          passportCode = data;

          this.$store.commit('SUGGESTIONS_SET_LOADER', {code_division: true}); // включаем лоадер, пока грузяться данные

          if(request) {
            request.abort(); // отменяем предыдующие запросы, если запросы не успели подгрузиться
          }

          request = await this.$store.dispatch('SUGGESTIONS_GET_CODE_DIVISION', data);

          request.onreadystatechange = function () {
            // получаем результат введеного кода подраздления
            if(request.readyState === XMLHttpRequest.DONE) {
              switch (request.status) {
                case 200:
                  this.$user.passportIssuedBy = JSON.parse(request.response).data.value;
                  break;
                case 400:
                  if (this.$getErrorCode(request.response) === 'code-does-not-exists') {
                    // this.vErrors.add('passportDivisionCode', 'Указанный код подразделения не существует');
                    this.$user.passportIssuedBy = '';
                  }
                  break;
              }
              this.$store.commit('SUGGESTIONS_SET_LOADER', {code_division: false});
              request = null;
            }
          }.bind(this);
        }
      }
    },
    updated () {
      let item = this.$validator.fields.items
      if (this.$user.passportIssuedBy !== null) {
        item[3].flags.valid = true
      }
      if (item[0].flags.valid && item[1].flags.valid && item[2].flags.valid && item[3].flags.valid) {
        this.$user.validate.step2.passportInformation = true
      }
    },
    mounted () {
      this.$validator.localize(REQUIRED_FIELD)
      this.$validator.localize(MIN_LENGHT)
      this.$validator.localize(MAX_LENGHT)
      this.checkPassportForUnique()
    }
  }
</script>

<style scoped lang="scss">
  .padding-30px {
    padding: 0 30px
  }
</style>

